#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include "usart.h"


void timer0_init()
{
	OCR0A = 0;
	OCR0B = 0;

    TCCR0A |= (1 << WGM01) | (1 << WGM00); // fast pwm cu top la 0xff
	TCCR0A |= (1 << COM0A1); // non-inverting mode
	TCCR0A |= (1 << COM0B1);
    TCCR0B |= (1 << CS00) | (1 << CS02) ; // prescaler 1024
}

int speed;
char last_char;
int is_running;

void go(char c, int speed) {
	switch(c) {
		case 'f': // Merge in fata 
			if (last_char == 's' || last_char == 'f') {
				PORTC &= ~(1 << PC1);
				PORTC |= (1 << PC0);
				
				PORTC &= ~(1 << PC3);
				PORTC |= (1 << PC2);
				
				OCR0A = speed; // de la 0 la 255
				OCR0B = speed;
				last_char = c;
			}
			break;
		
		case 'b': // Merge in spate
			if (last_char == 's' || last_char == 'b') { //daca era oprita mergi in spate sau daca mergea in spate  'b'
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC2);
				
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC3);
				
				OCR0A = speed; // de la 0 la 255
				OCR0B = speed;
				
				last_char = c;
			}
			break;
			
		case 'r': // Merge in dreapta
			if (last_char == 'f' || last_char == 'b') {
				OCR0A = speed; // de la 0 la 255
				OCR0B = speed / 2;
			}
			break;
		case 'l': // Merge in stanga
			if (last_char == 'f' || last_char == 'b') {
				OCR0A = speed / 2; // de la 0 la 255
				OCR0B = speed;
			}
			break;
			
		case 'p': // rotire stanga
			PORTC &= ~(1 << PC1);
			PORTC |= (1 << PC0);

			PORTC &= ~(1 << PC2);
			PORTC |= (1 << PC3);
			
			
			OCR0A = speed; // de la 0 la 255
			OCR0B = speed / 2;
			
			last_char = c;
			break;
		
		case 'q': // rotire dreapta
			PORTC &= ~(1 << PC0);
			PORTC |= (1 << PC1);
		
			PORTC &= ~(1 << PC3);
			PORTC |= (1 << PC2);
			
			
			OCR0A = speed / 2; // de la 0 la 255
			OCR0B = speed;
			
			last_char = c;
			break;
				

	}
}

int main()
{
	timer0_init();	
	
	USART0_init(); 
	
	DDRD |= (1 << PD7); // LED
	
	DDRB |= (1 << PB4); // enable a
	DDRB |= (1 << PB3); // enable b

	DDRC |= (1 << PC0); // out motor 1
	DDRC |= (1 << PC1); // out motor 1
	DDRC |= (1 << PC2); // out motor 2
	DDRC |= (1 << PC3); // out motor 2
	
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);

	is_running = 0;
	last_char = 's';
	
	speed = 128;
	
	PORTD &= ~(1 << PD7);
	while (1) {
		
		char c = USART0_receive();
		switch(c) {
			case '1': // viteza 1 :
				speed = 128;
				c = last_char;
				go(c, speed);
				break;

			case '2': // viteza 2 :
				speed = 192;
				c = last_char;
				go(c, speed);
				break;
	
			case '3': // viteza 3:
				speed = 255;
				c = last_char;
				go(c, speed);
				break;

				
			case 's': // oprire
				PORTC &= ~(1 << PC0);
				PORTC &= ~(1 << PC1);
				PORTC &= ~(1 << PC2);
				PORTC &= ~(1 << PC3);
				last_char = c;
				is_running = 0;
				speed = 128;
				break;
				
			default: 
				go(c, speed);
			
		}
		
	}
	
	return 0;
}